/*///////////////////////////////////////////////////////////////////////////
	
	ProgressBar.cpp
	
	(C) 2003 Radek Chalupa
	
///////////////////////////////////////////////////////////////////////////*/

#define WINVER 0x0501
#define _WIN32_WINNT 0x0501

#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <stdio.h>
#include <windows.h>

#include "resource.h"

#pragma comment (lib, "comctl32.lib")

/////////////////////////////////////////////////////////////////////////////

void NaTimer(HWND hWnd)
{
	MessageBeep(0); // zvukov signalizace
	// Zjistme aktuln log. pozici
	LRESULT Pozice = SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_GETPOS, 0,0);
	if ( Pozice < 20 )
	{
		Pozice++;
		// Nastavme novou pozici
		SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_SETPOS, Pozice,0);
	}
	else
	{
		KillTimer(hWnd, 1);
		// Vrtme se na zatek
		SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_SETPOS, 0,0);
	}
}

/////////////////////////////////////////////////////////////////////////////

void Spustit(HWND hWnd)
{
	// Nastavme rozsah
	SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_SETRANGE32, 0,20);
	// Nastavme (pro podek:-)) pozici na potek
	SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_SETPOS, 0,0);
	SetTimer(hWnd, 1, 1000, NULL);
}

/////////////////////////////////////////////////////////////////////////////

void SpustitAnimaci(HWND hWnd)
{
	SetWindowLongPtr(GetDlgItem(hWnd, IDC_PROGRESSBAR), GWL_STYLE,
		GetWindowLongPtr(GetDlgItem(hWnd, IDC_PROGRESSBAR), GWL_STYLE) | PBS_MARQUEE);
	SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_SETMARQUEE, TRUE, 100);
}

/////////////////////////////////////////////////////////////////////////////

void ZastavitAnimaci(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_PROGRESSBAR, PBM_SETMARQUEE, FALSE, 0);
	DWORD dwStyl = (DWORD)
		GetWindowLongPtr(GetDlgItem(hWnd, IDC_PROGRESSBAR), GWL_STYLE);
	dwStyl &=~ PBS_MARQUEE;
	SetWindowLongPtr(GetDlgItem(hWnd, IDC_PROGRESSBAR), GWL_STYLE, dwStyl);
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_SPUSTIT:
					Spustit(hWnd);
					break;
				case IDC_ANIMOVAT:
					if ( IsDlgButtonChecked(hWnd, IDC_ANIMOVAT) )
						SpustitAnimaci(hWnd);
					else
						ZastavitAnimaci(hWnd);
					break;
			}
			break;
			
		case WM_INITDIALOG:
			SendMessage(hWnd, WM_SETICON, ICON_SMALL | ICON_BIG,
				(LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_HLAVNI)));
			break;
		case WM_TIMER:
			NaTimer(hWnd);
			break;
	}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES;
	if ( !InitCommonControlsEx(&icc) )
	  return -1;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
